#ifndef _DATEEDT_H
#define _DATEEDT_H

#include <wics.h>
#include <edit.h>

#pragma option -Vo-
#if     defined(__BCOPT__) && !defined(_ALLOW_po)
#pragma option -po-
#endif

_CLASSDEF (TDateEdit)

class TDateEdit : public TEdit
{
private:
	virtual const Pchar streamableName() const { return "TDateEdit"; }

protected:
	virtual LPSTR GetClassName() { return "WICSDateEdit"; }
	virtual void SetupWindow();

    virtual void WMCommand(RTMessage) = [WM_FIRST + WM_COMMAND];

	TDateEdit(StreamableInit) : TEdit(streamableInit) {};

public:
	TDateEdit (PTWindowsObject AParent, int ResourceId, PTModule AModule = NULL);
	~TDateEdit ();

	int  GetLineLength();
	BOOL GetLine(LPSTR ATextString, int StrSize);
	BOOL DeleteLine(int) { return !(BOOL) SendMessage(HWindow, WM_CLEAR, 0, 0); }

	//	Redefine the following functions to do nothing. They serve no purpose in the 
	//	Date Edit control.
		
	BOOL CanUndo() { return FALSE; }
	int  GetLineFromPos(int) { return 0; }
    int  GetLineIndex(int) { return 0; }
	void Scroll(int, int) { return; }
	int  Search(int, LPSTR, BOOL) { return -1; }
	void GetSubText(LPSTR, int, int) { return; }

	virtual void GetDate (long & lDays, Rint iMonth, Rint iDay, Rint Year);
	virtual void GetMonth (Rint iMonth);
	virtual void GetDay (Rint iDay);
	virtual void GetYear (Rint iYear);

	virtual void GetEditParams (LPDECPARMS lpep);
	virtual void SetEditParams (LPDECPARMS lpep);

	static PTStreamable build();

};

inline Ripstream operator >> ( Ripstream is, RTDateEdit cl )
    { return is >> (RTStreamable )cl; }
inline Ripstream operator >> ( Ripstream is, RPTDateEdit cl )
    { return is >> (RPvoid)cl; }

inline Ropstream operator << ( Ropstream os, RTDateEdit cl )
    { return os << (RTStreamable )cl; }
inline Ropstream operator << ( Ropstream os, PTDateEdit cl )
    { return os << (PTStreamable )cl; }

#pragma option -Vo.
#if     defined(__BCOPT__) && !defined(_ALLOW_po)
#pragma option -po.
#endif

#endif